package com.example.phweingarten;

import java.util.ArrayList;
import java.util.HashMap;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import android.app.ProgressDialog;
import android.content.Intent;
import android.os.AsyncTask;
import android.os.Bundle;
import android.support.v7.app.ActionBarActivity;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.Button;
import android.widget.CheckBox;
import android.widget.ListAdapter;
import android.widget.ListView;
import android.widget.SimpleAdapter;
import android.widget.TextView;

import com.example.phweingarten.library.JSONParser;

public class FragenActivity extends ActionBarActivity {
	ListView list;
	TextView id;
	TextView frage;
	Button Btnpushdata;
	CheckBox antwort;

	ArrayList<HashMap<String, String>> oslist = new ArrayList<HashMap<String, String>>();
	// URL to get JSON Array
	private static String url = "http://193.197.56.153/medienprojekt/funktion_idauf.php";
	// JSON Node Names
	private static final String TAG_OS = "fragen";
	private static final String TAG_ID = "id";
	private static final String TAG_FRAGE = "frage";
	private static final String TAG_ANTWORT = "antwort";

	// private String frageLabel;

	JSONArray fragen = null;

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_fragen);

		oslist = new ArrayList<HashMap<String, String>>();
		new JSONParse().execute();
		Btnpushdata = (Button) findViewById(R.id.pushdata);
		Btnpushdata.setOnClickListener(new View.OnClickListener() {
			@Override
			public void onClick(View view) {

				Intent intentDankActivity = new Intent(FragenActivity.this,
						DankActivity.class);
				startActivity(intentDankActivity);
			}
		});

	}

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		// Inflate the menu; this adds items to the action bar if it is present.
		getMenuInflater().inflate(R.menu.fragen, menu);
		return true;
	}

	@Override
	public boolean onOptionsItemSelected(MenuItem item) {

		int id = item.getItemId();
		if (id == R.id.action_settings) {
			return true;
		}
		return super.onOptionsItemSelected(item);
	}

	private class JSONParse extends AsyncTask<String, String, JSONObject> {
		private ProgressDialog pDialog;

		@Override
		protected void onPreExecute() {
			super.onPreExecute();
			id = (TextView) findViewById(R.id.id);
			frage = (TextView) findViewById(R.id.frage);
			antwort = (CheckBox) findViewById(R.id.antwort);
			pDialog = new ProgressDialog(FragenActivity.this);
			pDialog.setMessage("Fragen werden abgerufen ...");
			pDialog.setIndeterminate(false);
			pDialog.setCancelable(true);
			pDialog.show();
		}

		@Override
		protected JSONObject doInBackground(String... args) {
			JSONParser jParser = new JSONParser();
			// Getting JSON from URL
			JSONObject json = jParser.getJSONFromUrl(url);
			return json;
		}

		@Override
		protected void onPostExecute(JSONObject json) {
			pDialog.dismiss();
			try {
				// Getting JSON Array from URL
				fragen = json.getJSONArray(TAG_OS);
				for (int i = 0; i < fragen.length(); i++) {
					JSONObject c = fragen.getJSONObject(i);
					// Storing JSON item in a Variable
					// String id = c.getString(TAG_ID);
					String frage = c.getString(TAG_FRAGE);
					String antwort = c.getString(TAG_ANTWORT);
					// Adding value HashMap key => value
					HashMap<String, String> map = new HashMap<String, String>();
					// map.put(TAG_ID, id);
					map.put(TAG_FRAGE, frage);
					map.put(TAG_ANTWORT, antwort);
					oslist.add(map);
					list = (ListView) findViewById(R.id.list);
					ListAdapter adapter = new SimpleAdapter(
							FragenActivity.this, oslist, R.layout.list_fragen,
							new String[] { TAG_ID, TAG_FRAGE, TAG_ANTWORT },
							new int[] { R.id.id, R.id.frage, R.id.antwort });
					list.setAdapter(adapter);

					// frageLabel = frage;
				}

			} catch (JSONException e) {
				e.printStackTrace();
			}

		}
	}
}